var svgIconConfig = {
	clock : {
		url : 'svg/clock.svg',
		animation : [
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "r0 32 32"}' },
					to : { val : '{"transform" : "r630 32 32"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val :'{"transform" : "r0 32 32"}' },
					to : { val : '{"transform" : "r80 32 32"}' }
				}
			},
		]
	},
	trash : {
		url : 'svg/trash.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}' },
					to : { val : '{"transform" : "t0 -8"}' }
				}
			}
		]
	},
	contract : {
		url : 'svg/contract.svg',
		animation : [
			{
				el : 'rect:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}', after : '{ "opacity" : 0 }' },
					to : { val : '{"transform" : "t-5 -5"}', before : '{ "opacity" : 1 }' }
				}
			},
			{
				el : 'rect:nth-child(3)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}', after : '{ "opacity" : 0 }' },
					to : { val : '{"transform" : "t-10 -10"}', before : '{ "opacity" : 1 }' }
				}
			}
		]
	},
	maximize : {
		url : 'svg/maximize.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}' },
					to : { val : '{"transform" : "t-5 -5"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}' },
					to : { val : '{"transform" : "t5 -5"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}' },
					to : { val : '{"transform" : "t-5 5"}' }
				}
			},
			{
				el : 'path:nth-child(4)',
				animProperties : {
					from : { val : '{"transform" : "t0 0"}' },
					to : { val : '{"transform" : "t5 5"}' }
				}
			}
		]
	},
	maximizeRotate : {
		url : 'svg/maximize.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "r0 16 16 t0 0"}' },
					to : { val : '{"transform" : "r180 16 16 t-5 -5"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "r0 48 16 t0 0"}' },
					to : { val : '{"transform" : "r-180 48 16 t5 -5"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"transform" : "r0 16 48 t0 0"}' },
					to : { val : '{"transform" : "r-180 16 48 t-5 5"}' }
				}
			},
			{
				el : 'path:nth-child(4)',
				animProperties : {
					from : { val : '{"transform" : "r0 48 48 t0 0"}' },
					to : { val : '{"transform" : "r180 48 48 t5 5"}' }
				}
			}
		]
	},
	volume : {
		url : 'svg/volume.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "t-10 0 s0 32 32"}' },
					to : { val : '{"transform" : "t0 0 s1 32 32", "opacity" : 1}', before : '{"transform" : "t-10 0 s0 32 32"}', delayFactor : .5 }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "t-10 0 s0 32 32"}', delayFactor : .25 },
					to : { val : '{"transform" : "t0 0 s1 32 32", "opacity" : 1}', before : '{"transform" : "t-10 0 s0 32 32"}', delayFactor : .25 }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"transform" : "t-10 0 s0 32 32"}', delayFactor : .5 },
					to : { val : '{"transform" : "t0 0 s1 32 32", "opacity" : 1}', before : '{"transform" : "t-10 0 s0 32 32"}' }
				}
			}
		]
	},
	plus : {
		url : 'svg/plus.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "r0 32 32", "opacity" : 1}' },
					to : { val : '{"transform" : "r180 32 32", "opacity" : 0}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "r0 32 32"}' },
					to : { val : '{"transform" : "r180 32 32"}' }
				}
			}
		]
	},
	plusCross : {
		url : 'svg/plus.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "r0 32 32"}' },
					to : { val : '{"transform" : "r45 32 32"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "r0 32 32"}' },
					to : { val : '{"transform" : "r45 32 32"}' }
				}
			}
		]
	},
	hamburger : {
		url : 'svg/hamburger.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"path" : "m 5.0916789,20.818994 53.8166421,0"}' },
					to : { val : '{"path" : "m 5.091679,9.771104 53.816642,0"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"path" : "m 5.0916788,42.95698 53.8166422,0"}' },
					to : { val : '{"path" : "m 5.0916789,54.00487 53.8166421,0"}' }
				}
			}
		]
	},
	hamburgerCross : {
		url : 'svg/hamburger.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"path" : "M 14.3 29.5 C 14.3 29.4 14.3 29.3 14.4 29.3 L 16.2 26 L 31.1 26 C 32.6 26 33.9 25.2 34.6 23.9 L 42.3 9.9 L 38.8 8 L 38.8 8 L 36.6 12 L 31.1 22 L 17.1 22 L 16.8 21.5 L 12.3 12 L 10.4 8 L 8.5 4 L 2 4 L 2 8 L 6 8 L 13.2 23.2 L 10.5 28.1 C 10.2 28.6 10 29.3 10 30 C 10 32.2 11.8 34 14 34 L 38 34 L 38 30 L 14.8 30 C 14.6 30 14.3 29.8 14.3 29.5 L 14.3 29.5 Z"}' },
					to : { val : '{"path" : "M 12 36 C 12 37.1 12.9 38 14 38 L 16 38 L 16 45 C 16 46.7 17.3 48 19 48 C 20.7 48 22 46.7 22 45 L 22 38 L 26 38 L 26 45 C 26 46.7 27.3 48 29 48 C 30.7 48 32 46.7 32 45 L 32 38 L 34 38 C 35.1 38 36 37.1 36 36 L 36 16 L 12 16 L 12 36 L 12 36 Z"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
          from : { val : '{"path" : "M 22 18 L 26 18 L 26 12 L 32 12 L 32 8 L 26 8 L 26 2 L 22 2 L 22 8 L 16 8 L 16 12 L 22 12 L 22 18 L 22 18 Z"}' },
          to : { val : '{"path" : "M 31.1 4.3 L 33.7 1.7 C 34.1 1.3 34.1 0.7 33.7 0.3 C 33.3 -0.1 32.7 -0.1 32.3 0.3 L 29.3 3.3 C 27.7 2.5 25.9 2 24 2 C 22.1 2 20.3 2.5 18.7 3.3 L 15.7 0.3 C 15.3 -0.1 14.7 -0.1 14.3 0.3 C 13.9 0.7 13.9 1.3 14.3 1.7 L 16.9 4.3 C 13.9 6.5 12 10 12 14 L 36 14 C 36 10 34.1 6.5 31.1 4.3 L 31.1 4.3 ZM 30 10 L 28 10 L 28 8 L 30 8 L 30 10 L 30 10 ZM 20 10 L 18 10 L 18 8 L 20 8 L 20 10 L 20 10 Z"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"path" : "M 34 36 C 31.8 36 30 37.8 30 40 C 30 42.2 31.8 44 34 44 C 36.2 44 38 42.2 38 40 C 38 37.8 36.2 36 34 36 L 34 36 Z"}' },
					to : { val : '{"path" : "M 41 16 C 39.3 16 38 17.3 38 19 L 38 33 C 38 34.7 39.3 36 41 36 C 42.7 36 44 34.7 44 33 L 44 19 C 44 17.3 42.7 16 41 16 L 41 16 Z"}' }
				}
			},
      {
        el : 'path:nth-child(4)',
        animProperties : {
          from : { val : '{"path" : "M 14 36 C 11.8 36 10 37.8 10 40 C 10 42.2 11.8 44 14 44 C 16.2 44 18 42.2 18 40 C 18 37.8 16.2 36 14 36 L 14 36 Z"}' },
          to : { val : '{"path" : "M 7 16 C 5.3 16 4 17.3 4 19 L 4 33 C 4 34.7 5.3 36 7 36 C 8.7 36 10 34.7 10 33 L 10 19 C 10 17.3 8.7 16 7 16 L 7 16 Z"}' }
        }
      }
		]
	},
	navLeftArrow : {
		url : 'svg/nav-left-arrow.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "M 48.592939,9.792208 15.407062,31.887987 48.592939,54.025974"}' },
					to : { val : '{"path" : "M 15.407062,9.792208 48.592939,31.887987 15.407062,54.025974"}' }
				}
			}
		]
	},
	navUpArrow : {
		url : 'svg/nav-up-arrow.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "M 9.8831175,48.502029 31.978896,15.316152 54.116883,48.502029"}' },
					to : { val : '{"path" : "M 9.8831175,15.316152 31.978896,48.502029 54.116883,15.316152"}' }
				}
			}
		]
	},
	rightArrow : {
		url : 'svg/right-arrow.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "M 34.419061,13.24425 57.580939,32.017897 34.419061,50.75575"}' },
					to : { val : '{"path" : "M 31.580939,13.24425 8.419061,32.017897 31.580939,50.75575"}' }
				}
			}
		]
	},
	downArrow : {
		url : 'svg/down-arrow.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "M 14.083963,33.258774 32.85761,56.420652 51.595463,33.258774"}' },
					to : { val : '{"path" : "M 14.083963,30.420652 32.85761,7.258774 51.595463,30.420652"}' }
				}
			}
		]
	},
	smiley : {
		url : 'svg/smiley.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "m 19.380224,39.901132 c 0,0 4.860771,5.28501 12.770151,5.28501 7.909379,0 12.770152,-5.28501 12.770152,-5.28501"}' },
					to : { val : '{"path" : "m 19.380224,45.186142 c 0,0 4.860771,-5.28501 12.770151,-5.28501 7.909379,0 12.770152,5.28501 12.770152,5.28501"}' }
				}
			}
		]
	},
	play : {
		url : 'svg/play.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "M 18.741071,52 31.30178,42.531655 45.258928,31.887987 18.741071,12 z"}' },
					to : { val : '{"path" : "m 12.5,52 39,0 0,-40 -39,0 z"}' }
				}
			}
		]
	},
	mail : {
		url : 'svg/mail.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "m 61.693118,24.434001 -59.386236,0 29.692524,19.897984 z"}' },
					to : { val : '{"path" : "m 61.693118,24.434001 -59.386236,0 29.692524,-19.7269617 z"}' }
				}
			}
		]
	},
	equalizer : {
		url : 'svg/equalizer.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "t 0 0"}' },
					to : { val : '{"transform" : "t 0 -30"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "t 0 0"}' },
					to : { val : '{"transform" : "t 0 35"}' }
				}
			},
			{
				el : 'path:nth-child(3)',
				animProperties : {
					from : { val : '{"transform" : "t 0 0"}' },
					to : { val : '{"transform" : "t 0 -10"}' }
				}
			}
		]
	},
	glass : {
		url : 'svg/glass.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "m 16.778805,44 c 0,0 9.518312,-3.481153 13.221195,-2 10,4 17.153596,2 17.153596,2 L 45,54 20,54 z"}' },
					to : { val : '{"path" : "M 13.183347,29 C 13.183347,29 25,31.439358 30,29 c 12.710171,-6.200932 20,0 20,0 l -5,25 -25,0 z"}' }
				}
			}
		]
	},
	hourglass : {
		url : 'svg/hourglass.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "r 0 32 32"}' },
					to : { val : '{"transform" : "r 180 32 32"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "r 0 32 32"}', animAfter : '{"path" : "m 31,32 2,0 0,0 9,15 -20,0 9,-15 z"}' },
					to : { val : '{"transform" : "r 180 32 32"}', animAfter : '{"path" : "m 22,17 20,0 -9,15 0,0 -2,0 0,0 z"}' }
				}
			}
		]
	},
	padlock : {
		url : 'svg/padlock.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"transform" : "t 0 0"}' },
					to : { val : '{"transform" : "t 0 -11"}' }
				}
			}
		]
	},
	zoom : {
		url : 'svg/zoom.svg',
		animation : [
			{
				el : 'path:nth-child(1)',
				animProperties : {
					from : { val : '{"transform" : "s 1 1"}' },
					to : { val : '{"transform" : "s 1.1 1.1"}' }
				}
			},
			{
				el : 'path:nth-child(2)',
				animProperties : {
					from : { val : '{"transform" : "s 1 1", "stroke-width" : "1"}' },
					to : { val : '{"transform" : "s 2 2", "stroke-width" : "2"}' }
				}
			}
		]
	},
	monitor : {
		url : 'svg/monitor.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "m 5,11.75 0,33.75 20.25,0 -6.75,6.75 27,0 -6.75,-6.75 20.25,0 0,-33.75 -54,0 z m 2.65625,2.875 48.6875,0 0,27.8125 -48.6875,0 0,-27.8125 z"}' },
					to : { val : '{"path" : "m 21.875,16.8125 0,30.375 3.375,0 3.5,0 3.25,0 6.75,0 3.375,0 0,-30.375 -20.25,0 z m 3.375,3.375 13.5,0 0,20.25 -13.5,0 0,-20.25 z m 6.75,22.25 c 0.756641,0 1.375,0.618359 1.375,1.375 0,0.756641 -0.618359,1.375 -1.375,1.375 -0.756641,0 -1.375,-0.618359 -1.375,-1.375 0,-0.756641 0.618359,-1.375 1.375,-1.375 z"}' }
				}
			}
		]
	},
	flag : {
		url : 'svg/flag.svg',
		animation : [
			{
				el : 'path',
				animProperties : {
					from : { val : '{"path" : "m 11.75,11.75 c 0,0 10.229631,3.237883 20.25,0 10.020369,-3.2378833 20.25,0 20.25,0 l 0,27 c 0,0 -6.573223,-3.833185 -16.007359,0 -9.434136,3.833185 -24.492641,0 -24.492641,0 z"}' },
					to : { val : '{"path" : "m 11.75,11.75 c 0,0 8.373476,-4.8054563 17.686738,0 9.313262,4.805456 22.813262,0 22.813262,0 l 0,27 c 0,0 -11.699747,4.363515 -22.724874,0 C 18.5,34.386485 11.75,38.75 11.75,38.75 z"}' }
				}
			}
		]
	}
};